import { EventEmitter } from "events";

const event = new EventEmitter

/** @type {Object} */
const kafka = {}
kafka.consume('chargepoint-callresult', (msg) => {
  event.removeAllListeners(`event:chargepoint-callerror:${msg.uniqueId}`)
  event.emit(`event:chargepoint-callresult:${msg.uniqueId}`, msg)
})

kafka.consume('chargepoint-callerror', (msg) => {
  event.removeAllListeners(`event:chargepoint-callresult:${msg.uniqueId}`)
  event.emit(`event:chargepoint-callerror:${msg.uniqueId}`, msg)
})

kafka.consume('chargepoint-call', (msg) => {
  const replyFunc = (err, replyPayload) => {
    if(err){
      kafka.produce(`ocpp-callerror-${msg.chargeBoxId}`, {
        uniqueId: msg.uniqueId,
        // ... error payload
      })
    }else{
      kafka.produce(`ocpp-callresult-${msg.chargeBoxId}`, {
        uniqueId: msg.uniqueId,
        payload: replyPayload
      })
    }
  }
  event.emit('StartTransaction', msg, replyFunc)
})

function call(){
  return new Promise((resolve, reject) => {
    const uniqueId = 'abc-123'

    event.once(`event:chargepoint-callresult:${uniqueId}`, (msg) => {
      resolve(msg);
    })

    event.once(`event:chargepoint-callerror:${uniqueId}`, (msg) => {
      reject(msg);
    })

    kafka.produce('ocpp-call-{chargeBoxId}', {action: '...', uniqueId: uniqueId})
  })
}

event.on('StartTransaction', (msg, reply) =>{
  reply(null, {
    status: "Accepted",
    transactionId: 1234
  })
})



const result = await call()